routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/




Route::middleware(['auth:sanctum', 'verified'])->group(function () {
    Route::get('/', function () {
        return redirect()->route('news.index');
    })->name('home');

    Route::get('/dashboard', function () {
        return view('dashboard');
    })->name('dashboard');

    Route::get('/companies','App\Http\Controllers\CompaniesController@index')->name('companies');
    Route::resource('news','App\Http\Controllers\NewsController');

});

app/Models/News.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class News extends Model
{
    use HasFactory;
    public function companies(){
        return $this->belongsToMany(Company::class,'company_new','company_id', 'news_id');
    }
    public function language(){
        return $this->belongsTo(Language::class,'language','id');
    }
}

app/Http/Controllers/NewsController.php
<?php

namespace App\Http\Controllers;

use App\Models\Company;
use App\Models\Language;
use App\Models\News;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Image;
class NewsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $news = News::with('companies','language')->paginate(25);
        return view('news.index',compact('news'));
    }
 
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        $languages = Language::all();
        $companies = Company::all();
        return view('news.add_news',compact('languages','companies'));

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  request()
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // return request()->all();
        request()->validate( [
            'url'              => 'required|url',
            'language'          => 'required',
            'title'          => 'required',
            'summary'          => 'required',
            'file'          => 'required',
            'companies'     =>'required',
        ]);

   
        $image_name = 'img_'.time().'.'.request()->file('file')->getClientOriginalExtension();
        $image = Image::make(request()->file('file'));
        $image->save(public_path("news_images/$image_name"));
        

        $news = new News();
        $news->url = request()->url;
        $news->language = request()->language;
        $news->title = request()->title;
        $news->summary = request()->summary;
        $news->image = $image_name;
        $news->save();
     
        $news->companies()->sync(request()->companies);

        \Session::flash('success_msg','News saved successfully!');
        return redirect()->route('news.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $news = News::with('companies','language')->find($id);
        $selected = $news->companies->pluck('id')->toArray();
        $languages = Language::all();
        $companies = Company::all();
        return view('news.edit_news',compact('news','languages','companies','selected'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update($id)
    {
        request()->validate( [
            'url'              => 'required|url',
            'language'          => 'required',
            'title'          => 'required',
            'summary'          => 'required',
            'companies'     =>'required',
        ]);

        $news = News::with("companies")->find($id);
        
        if(isset(request()->file) AND !empty(request()->file)){
            $image_name = 'img_'.time().'.'.request()->file('file')->getClientOriginalExtension();
            $image = Image::make(request()->file('file'));
            $image->save(public_path("news_images/$image_name"));

            $news->image = $image_name;

        }

        $news->url = request()->url;
        $news->language = request()->language;
        $news->title = request()->title;
        $news->summary = request()->summary;
        $news->save();
        
        $news->companies()->sync(request()->companies);

        \Session::flash('success_msg','News saved successfully!');
        return redirect()->route('news.index');

    }


    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/news/add_news.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('News') }}
        </h2>
    </x-slot>

    <div class="py-12">
      <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
      {{--  <div class="block mb-8">
          <a type="button" href="{{route('news')}}" class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-green-600 text-base font-medium text-white focus:outline-none focus:ring-2 focus:ring-offset-2 sm:ml-3 sm:w-auto sm:text-sm">
            Return
          </a>
        </div>--}}

          <form enctype="multipart/form-data" method="post" action="{{route('news.store')}}" class="w-full max-w-lg">
              @csrf
              <div class="flex flex-wrap -mx-3 mb-2">
                <div class="w-full px-3">
                    <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                        Select Language
                    </label>
                    <select  class=" appearance-none w-full  border border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight focus:outline-none focus:bg-white focus:border-gray-500" name="language" value="{{ old('language') }}">
                        <option value="">Select Language</option>
                         @foreach($languages as $language)
                             <option class="capitalize" value="{{$language->id}}">{{$language->name}}</option>
                         @endforeach
                     </select>
                    @if ($errors->has('language'))
                        <span class="text-danger" style="color: red">{{ $errors->first('language') }}</span>
                    @endif
                </div>
            </div>
            
              <div class="flex flex-wrap -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                          Title
                      </label>
                      <input class="appearance-none block w-full  text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500" id="grid-password" type="text" name="title" value="{{ old('title') }}" placeholder="Enter Title Here">
                      @if ($errors->has('title'))
                          <span class="text-danger" style="color: red">{{ $errors->first('title') }}</span>
                      @endif
                  </div>
              </div>
              <div class="flex flex-wrap -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                          Url
                      </label>
                      <input class="appearance-none block w-full  text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500" id="grid-password" type="url" name="url" value="{{ old('url') }}" placeholder="Enter Title Here">
                      @if ($errors->has('url'))
                          <span class="text-danger" style="color: red">{{ $errors->first('url') }}</span>
                      @endif
                  </div>
              </div>

              <div class="flex  -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                          Summary
                      </label>
                      <textarea name="summary" value="{{ old('summary') }}" class="form-textarea mt-1  w-full" rows="3" placeholder="Enter some long form content."></textarea>
                      @if ($errors->has('summary'))
                          <span class="text-danger" style="color: red">{{ $errors->first('summary') }}</span>
                      @endif
                  </div>
              </div>
       
              <div class="flex flex-wrap -mx-3 mb-2">
                <div class="w-full px-3">
                    <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                        Select Companies
                    </label>
                  
                     <select multiple class="select2 appearance-none w-full  border border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight focus:outline-none focus:bg-white focus:border-gray-500" name="companies[]">
                        <option value="">Select Companies</option>
                        @foreach($companies as $company)
                            <option class="capitalize" value="{{$company->id}}">{{$company->name}}</option>
                        @endforeach
                    </select>
                    @if ($errors->has('companies'))
                        <span class="text-danger" style="color: red">{{ $errors->first('companies') }}</span>
                    @endif
                </div>
            </div>

              <div class="flex flex-wrap -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                         Image
                      </label>
                      <input class="appearance-none block w-full  text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500" type="file" name="file">
                      @if ($errors->has('file'))
                        <span class="text-danger" style="color: red">{{ $errors->first('file') }}</span>
                      @endif
                  </div>
              </div>
              <button class="flex-shrink-0 bg-green-500 hover:bg-teal-700 border-teal-500 hover:border-teal-700 text-sm border-4 text-white py-1 px-2 rounded" type="submit">
                  Submit
              </button>

          </form>

      </div>
    </div>
</x-app-layout>

resources/views/news/edit_news.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Edit News') }}
        </h2>
    </x-slot>

    <div class="py-12">
      <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
      {{--  <div class="block mb-8">
          <a type="button" href="{{route('news')}}" class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-green-600 text-base font-medium text-white focus:outline-none focus:ring-2 focus:ring-offset-2 sm:ml-3 sm:w-auto sm:text-sm">
            Return
          </a>
        </div>--}}

          <form enctype="multipart/form-data" method="post" action="{{route('news.update',$news->id)}}" class="w-full max-w-lg">
            @method('put')
              @csrf
              <div class="flex flex-wrap -mx-3 mb-2">
                <div class="w-full px-3">
                    <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                        Select Language
                    </label>
                    <select  class=" appearance-none w-full  border border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight focus:outline-none focus:bg-white focus:border-gray-500" name="language" value="{{ old('language') }}">
                        <option value="">Select Language</option>
                         @foreach($languages as $language)
                             <option {{$language->id == $news->language ? 'selected' : ''}} class="capitalize" value="{{$language->id}}">{{$language->name}}</option>
                         @endforeach
                     </select>
                    @if ($errors->has('language'))
                        <span class="text-danger" style="color: red">{{ $errors->first('language') }}</span>
                    @endif
                </div>
            </div>
              <div class="flex flex-wrap -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                          Title
                      </label>
                      <input class="appearance-none block w-full  text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500" id="grid-password" type="text" name="title" value="{{ $news->title }}" placeholder="Enter Title Here">
                      @if ($errors->has('title'))
                          <span class="text-danger" style="color: red">{{ $errors->first('title') }}</span>
                      @endif
                  </div>
              </div>
              <div class="flex flex-wrap -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                          Url
                      </label>
                      <input class="appearance-none block w-full  text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500" id="grid-password" value="{{$news->url}}" type="url" name="url" placeholder="Enter Title Here">
                      @if ($errors->has('url'))
                          <span class="text-danger" style="color: red">{{ $errors->first('url') }}</span>
                      @endif
                  </div>
              </div>

              <div class="flex  -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                          Summary
                      </label>
                      <textarea  name="summary" class="form-textarea mt-1  w-full" rows="3" placeholder="Enter some long form content.">{{$news->summary}}</textarea>
                      @if ($errors->has('summary'))
                          <span class="text-danger" style="color: red">{{ $errors->first('summary') }}</span>
                      @endif
                  </div>
              </div>
              <div class="flex flex-wrap -mx-3 mb-2">
                <div class="w-full px-3">
                    <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                        Select Companies
                    </label>
                  
                     <select multiple class="select2 appearance-none w-full  border border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight focus:outline-none focus:bg-white focus:border-gray-500" name="companies[]">
                        <option value="">Select Companies</option>
                        @foreach($companies as $company)
                            <option {{in_array($company->id,$selected) ? 'selected' : ''}} class="capitalize" value="{{$company->id}}">{{$company->name}}</option>
                        @endforeach
                    </select>
                    @if ($errors->has('companies'))
                        <span class="text-danger" style="color: red">{{ $errors->first('companies') }}</span>
                    @endif
                </div>
            </div>
              <div class="flex flex-wrap -mx-3 mb-2">
                  <div class="w-full px-3">
                      <label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
                         Image
                      </label>
                      <input class="appearance-none block w-full  text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500" id="grid-password" type="file" name="file">
                      @if ($errors->has('file'))
                      <span class="text-danger" style="color: red">{{ $errors->first('file') }}</span>
                        @endif
                  </div>
              </div>
              <button class="flex-shrink-0 bg-green-500 hover:bg-teal-700 border-teal-500 hover:border-teal-700 text-sm border-4 text-white py-1 px-2 rounded" type="submit">
                  Submit
              </button>

          </form>

      </div>
    </div>
</x-app-layout>

resources/views/news/index.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('News') }}
        </h2>
    </x-slot>

    <div class="py-12">
      <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div class="block mb-8">
          <a type="button" href="{{route('news.create')}}" class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-green-600 text-base font-medium text-white focus:outline-none focus:ring-2 focus:ring-offset-2 sm:ml-3 sm:w-auto sm:text-sm">
            Add
          </a>
        </div>
            <div class="flex flex-col">
              <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
                <div class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8">
                  <div class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg">
                    <table class="min-w-full divide-y divide-gray-200">
                      <thead class="bg-gray-50">
                        <tr>
                          <th scope="col" class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                            Name
                          </th>
                            <th scope="col" class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                            Companies
                          </th>
                          <th scope="col" class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                            Image
                          </th>
                          <th scope="col" class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                            URL
                          </th>
                            <th scope="col" class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                           Action
                          </th>

                        </tr>
                      </thead>
                      <tbody class="bg-white divide-y divide-gray-200">
                        @foreach ($news as $value)
                        <tr>
                          <td class="px-6 py-4 whitespace-nowrap">
                            <div class="flex items-center">
                              <div class="ml-4">
                                <div class="text-sm font-medium text-gray-900">
                                  {{$value->title}}
                                </div>
                              </div>
                            </div>
                          </td>
                            <td class="px-6 py-4 whitespace-nowrap">
                            <div class="flex items-center">
                              <div class="ml-4">
                                  @if(count($value->companies)>0)
                                  @foreach($value->companies as $company_data)
                                      <span class="inline-flex items-center justify-center px-2 py-1 text-xs font-bold leading-none text-indigo-100 bg-indigo-700 rounded"> {{$company_data['name']}}</span>
                                  @endforeach
                                      @else
                                      <span class="inline-flex items-center justify-center px-2 py-1 text-xs font-bold leading-none text-indigo-100 bg-red-600 rounded"> N/A</span>
                                      @endif
                              </div>
                            </div>
                          </td>

                          <td class="px-6 py-4 whitespace-nowrap">
                            <div class="flex items-center">
                              <div class="ml-4">
                                <img src="{{asset('news_images')}}/{{$value->image}}" style="width:80px">
                              </div>
                            </div>
                          </td>

                          <td class="px-6 py-4 whitespace-nowrap">
                            <div class="flex items-center">
                              <div class="ml-4">
                               <a href="{{$value->url}}" target="_blank"><u>Details</u></a>
                              </div>
                            </div>
                          </td>
                            <td class="px-6 py-4 whitespace-nowrap">
                                <div class="flex items-center">
                                    <div class="ml-4">
                                        <div class="text-sm font-medium text-gray-900">
                                            <a type="button" href="{{route('news.edit',$value->id)}}" class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-green-600 text-base font-medium text-white focus:outline-none focus:ring-2 focus:ring-offset-2 sm:ml-3 sm:w-auto sm:text-sm">
                                                Edit
                                            </a>
                                        </div>
                                    </div>
                                </div>
                            </td>

                        </tr>
                        @endforeach
                      </tbody>

                    </table>
                    {{$news->links()}}

                  </div>
                </div>
              </div>
            </div>
      </div>
    </div>
</x-app-layout>